<template>
  <span class="modal_3">
    <!-- Details Button -->
     <div class="modal "  v-bind:class="{ active: isActive }"   id="modal-id">
      <div class="modal-container container2" v-if="display_4" >
        
      <!-- <div class="columns">
        <div class="column col-2 col-ml-auto ">
          <h5>X</h5>
        </div>
      </div> -->
        
        <div class="">
          
          <form id="submitNewPackage">
            <div class="columns">
              <div class="column col-12"><p class="alert alert-info info-alert" role="alert" v-if="alert_successful">Package Assigned Successfully</p></div>
              <div class="column col-4">
                <div class="form-group">
                  <label for="package" class="form-label">Package</label>
                  <select v-model="package_id" name="package" class="form-input f_space form-input-edit" v-on:change="getEarnings">
                    <option value>Select Package</option>
                    <option
                      v-for="employeePackage in employeePackages"
                      v-bind:value="employeePackage.id"
                      :key="employeePackage.id"
                    >{{ employeePackage.tag }} - {{ employeePackage.description }}</option>
                  </select>
                </div>
              </div>
              <div class="column col-4">
                <div class="form-group">
                  <label for="startDate" class="form-label">Start Date</label>
                  <input v-model="startDate" type="date" class="form-input f_space form-input-edit">
                </div>
              </div>
              <div class="column col-4">
                <div class="form-group">
                  <label for="endDate" class="form-label">End Date</label>
                  <input v-model="endDate" type="date" class="form-input f_space form-input-edit">
                </div>
              </div>
              <div class="column col-4">
                <div class="form-group t_space">
                  <button class="btn btn-package1" @click="assign">Add Package</button>
                  <!-- <button class="btn btn-package2<" @click="close">Cancel</button> -->
                </div>
              </div>

              <div class></div>
            </div>
          </form>

          <div class="t_space" v-if="t_earnings">
            <table class="table table-striped table-hover">
              <tr>
                
                  <th>Type</th>
                  <th>Frequency</th>
                  <th>Basis</th>
                  <th>Rate</th>
                
              </tr>
              <tr v-for="item in earnings" v-bind:key="item.id">
                <td>{{item.type}}</td>
                <td>{{item.frequency}}</td>
                <td>{{item.basis}}</td>
                <td>{{item.rate}}</td>

              </tr>
            </table>
          </div>
          
        </div>

      </div>
      <a href="#close" class="modal-overlay" aria-label="Close"></a>
      <div class="modal-container " id ="modalContainer" v-bind:class="{ inactive: display_2 }">
        <div class="modal-header" v-bind:class="{ inactive: display_2 }">
         <div class="heading1" v-if="display_2" >
           <a v-on:click="close" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <p class="alert alert-info info-alert" role="alert" v-bind:class="{ show_success: successful }">Employee Record Updated Successfully</p>
            <div class="modal-title h5">{{this.value.name}} </div>
            <div class="modal-title small_text1">{{this.value.role}}</div>
            </div>
            <div class="heading" v-if="display_3">
              <!-- <p class="alert alert-info info-alert" role="alert" v-bind:class="{ show_success: successful }">Employee Record Updated Successfully</p> -->
              <a href="#close" v-on:click="close" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <div class="modal-title h5">Edit Employee </div>
              <div class="modal-title small_text ">Employee Information</div>
            </div>
          </div>
        <div class="modal-body" v-bind:class="{ inactive: display_2 }">
        <div class="modal_content" id="content">
          <!-- content here -->
        
            <Form3 :currentEmployee=currentEmployee v-if="display_3"  @submit="updateCompletion"/>
            <Form2 @select="displayPackageModal" @submit="populateEditForm" :value=value v-if="display_2" :enable_field=enable_field />
        </div>
        </div>
       </div>
      </div>
    </span>
</template>

<script>
import axios from "axios"

import Form2 from './show-employee.vue'
import Form3 from './edit-employee.vue'
import { mapGetters } from 'vuex'
export default {
  name:'modal_3',
  props:['row_data', 'display_show_modal'],
  components: {      Form2, Form3  },
    
  data:function(){
    return{
      show_modal:false,
      successful: true,
      currentEmployee:'',
      display_2:true,
      display_1:false,
      display_3:false,
      display_4: false,
      title: '',
      first_name: ' ',
      surname: ' ',
      middle_name: ' ',
      email: ' ',
      country: ' ',
      phone: ' ',
      address: ' ',
      state: ' ',
      dob: ' ',
      role: ' ',
      gender: ' ',
      marital_status: ' ',
      children: ' ',
      dependents: ' ',
      value:this.row_data,
      isActive :true,
      count: 0,
      showForm:false,
      package_list:[],
      enable_field:false,
      employeePackages: [],
      button: true,
      earnings: [],
      startDate: '',
      endDate: '',
      package_id: "",
      t_earnings: true,
      params: {
        employee_id: "",
        package_id: ""
      },
      csrf: window.csrf_token,
      alert_successful: false
    }  
  },
    computed: {
    ...mapGetters([
      'employee_data',
      'clicked_employee' 
    ])
    },
    mounted() {
      var self = this;
      axios
      .get("/api/list_packages")
      .then(function(response) {
        console.log(response.data.packages);
        self.employeePackages = response.data.packages;
       })
        .catch(function(error) {
          console.log(error);
        });
    },
    // define methods under the `methods` object
    methods: {
      getEarnings() {
        var self = this;
        axios.get("/api/earnings/"+this.package_id).then(function(response){
          console.log(response.data.earning)
          self.earnings = response.data.earning
        })
        .catch(function (error) {
          console.log(error)
        })
        this.t_earnings = true
      },
      assign(e) {
        e.preventDefault();
        var self = this;
        self.params = {
          employee_id: this.row_data.id,
          package_id: this.package_id
        }
        this.earnings[startDate] = this.startDate
        this.earnings[endDate] = this.endDate
        console.log(self.params)
        var url = "api/assign_package"
        let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
        axios.post( url, self.params, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}}).then((response)=>{
          // console.log(data);
          console.log("Package Assigned")          
        })
        .catch(function (error) {
          console.log(error)
        })

        var url2 = '/api/earnings'
        var params = {employee:this.row_data.id, earning:this.earnings};
        console.log(params)
        axios.post( url2, params, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
        .then((response)=>{
        console.log(params)
        ;})
        this.alert_successful = true
      },
      AddDetails: function (event) {
        this.isActive=true,
        this.showForm =true
                     
      },
      close:function (event) {
        this.display_2=true;
        this.display_3=false;
        this.display_4=false;
        this.show_modal=false;
        this.$emit('close', this.show_modal);
        
      },
      updateCompletion:function(e){
        this.successful= false;
        this.display_2= true,
        this.display_3= false,
        setTimeout (()=> {
        this.successful = true}, 3000);
        this.$emit("select",  this.modal_display);
        this.value=this.clicked_employee;
        
          
      },
      populateShowPage:function(e){
        this.value=row_data;
        this.display_2=true;
        setTimeout (()=> {
        this.successful = true }, 3000);
        },
      populateEditForm:function(currentEmployee, display1, display2){
        this.display_3=display1,
        this.display_2=display2,
        this.currentEmployee=currentEmployee;
},
      cancel_modal:function (event) {
        this.display_4= false;
        this.enable_field=true;
        //this.$refs.Form2.setValue(false);
        
      },
      displayPackageModal:function(modal_display){
        this.display_4= modal_display;
        var package_url = "/api/packages";
        const axios = require('axios');
        axios.get(package_url).then((response)=>{
        this.package_list= response.data.packages
        console.log(this.package_list)

      })

      }

}
      }

</script>
<style >

</style>